unit UnMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Buttons, MailIt, FliPlayerTimer;

type
  TForm1 = class(TForm)
    Details: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Controls: TPanel;
    btPlay: TBitBtn;
    btContinue: TBitBtn;
    btPause: TBitBtn;
    btStop: TBitBtn;
    BitBtn1: TBitBtn;
    btOpenFlic: TBitBtn;
    CheckBox2: TCheckBox;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    Label13: TLabel;
    RPos: TRadioGroup;
    btPreview: TBitBtn;
    btSeek: TBitBtn;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    SpinEdit2: TSpinEdit;
    Label14: TLabel;
    Label16: TLabel;
    Label15: TLabel;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    btFullScreen: TButton;
    btReturn: TBitBtn;
    FliPlayer1: TFliPlayerTimer;
    Image1: TImage;
    Label21: TLabel;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FliPlayer1FliNextFrame(Sender: TObject; FrameNo: Word);
    procedure FliPlayer1Click(Sender: TObject);
    procedure FliPlayer1FliEnd(Sender: TObject; FrameNo: Word);
    procedure GiveState;
    procedure Timer1Timer(Sender: TObject);
    procedure btPlayClick(Sender: TObject);
    procedure btStopClick(Sender: TObject);
    procedure btOpenFlicClick(Sender: TObject);
    procedure btSeekClick(Sender: TObject);
    procedure btPreviewClick(Sender: TObject);
    procedure btContinueClick(Sender: TObject);
    procedure btPauseClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FliPlayer1FliPaint(Sender: TObject; FrameNo: Word);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpinEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure RPosClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure btFullScreenClick(Sender: TObject);
    procedure btReturnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  StartTime : LongInt;
  TotFrames : Integer;

implementation

uses unAbout, unReadme;

{$R *.DFM}

Var
 Showtext : Boolean = true;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  FliPlayer1.Loop:=Checkbox1.Checked;
  // Should animation loop back to first frame at the end?
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 FliPlayer1.Stretch:=CheckBox2.Checked;
 // Stretches animation onto whole canvas
 // Much slower than animation that is not stretched
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  try     // If you get an error here - try turning of "Break on exception
          // under the Tools-Enviroment Options
          // Or just compile and run the exe file
    FliPlayer1.SpeedOverride:=Word(SpinEdit1.Value);
  except
    FliPlayer1.SpeedOverride:=0;
  end;

  //This overrides the default speed of the animation
  // Value 1000 make up one second
  // Value of 0 means default speed should apply
end;

procedure TForm1.GiveState;
Var
 DTime : LongInt;
Begin
 //This procedure updates the display if tech info
 With FliPlayer1 do
  Begin
    case state of
     FliStop  : Label2.Caption:='FliStop';
     FliPlay  : Label2.Caption:='FliPlay';
     FliPause : label2.Caption:='FliPause';
    End;

    Label7.Caption:=IntToStr(CurrentFrame);
    label8.caption:=IntToStr(TotalFrames);

    DTime:=GetTickCount-StartTime;
    IF State=FliPlay then
     Begin
       Label19.Caption:=IntToStr(Round(TotFrames/((DTime/1000)+0.0001)));
       IF SpeedOverride=0 then
         Label20.Caption:=Inttostr(Round(1000/(DefSpeed+1)))
       Else
         Label20.Caption:=Inttostr(Round(1000/(SpeedOverride+1)));
     end;

    Label9.Caption:=IntToStr(DefSpeed);
    Label10.Caption:=IntToStr(FliWidth);
    Label11.Caption:=IntToStr(FliHeight);

  End;

End;

procedure TForm1.FliPlayer1FliNextFrame(Sender: TObject; FrameNo: Word);
begin
  // On nextframe event handler
  GiveState;
  Inc(TotFrames);
end;



procedure TForm1.FliPlayer1Click(Sender: TObject);
begin
 //Handles the clicks of the mouse on the component
 StartTime:=GetTickCount;
 TotFrames:=0;
 With FliPlayer1 do
  If State = FliPlay then
    Pause
  Else Continue;
end;

procedure TForm1.FliPlayer1FliEnd(Sender: TObject; FrameNo: Word);
begin
 //Called when Animation ends
 GiveState;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 GiveState;
end;

procedure TForm1.btPlayClick(Sender: TObject);
begin
  //Starts animation
  FliPlayer1.Play;
  StartTime:=GetTickCount;
  TotFrames:=0;
end;

procedure TForm1.btStopClick(Sender: TObject);
begin
 //stop animation
 FliPlayer1.Stop;
end;

procedure TForm1.btOpenFlicClick(Sender: TObject);
begin
 // open new animation
 If OpenDialog1.Execute then
  begin
    FliPlayer1.FileName:=OpenDialog1.FileName;
    fliPlayer1.Preview(1);
  end;
end;

procedure TForm1.btSeekClick(Sender: TObject);
begin
 // seek frame in animation
 Fliplayer1.Canvas.TextOut(5,5,'Seeking frame. Please wait...');
 FliPlayer1.SeekFrame(SpinEdit2.Value);
 StartTime:=GetTickCount;
 TotFrames:=0;
end;

procedure TForm1.btPreviewClick(Sender: TObject);
Var
 T : Cardinal;
begin
 //preview frame in animation
 //use this when the animation state is FliStop
 Fliplayer1.Canvas.Brush.Style:=bsSolid;
 FliPlayer1.Canvas.Brush.Color:=clBtnFace;
 Fliplayer1.Canvas.TextOut(5,5,'Seeking frame. Please wait...');
 T:=GetTickCount;
 IF FliPlayer1.Preview(SpinEdit2.Value) then
  Begin
   T:=GetTickCount-T;
   Fliplayer1.Canvas.TextOut(5,5,'Frame found in '+InttoStr(T div 1000)+'.'+IntToStr(T mod 1000)+' seconds! Not bad Eh!');
  End;
end;

procedure TForm1.btContinueClick(Sender: TObject);
begin
 // Resumes animation
 FliPlayer1.Continue;
 StartTime:=GetTickCount;
 TotFrames:=0;
end;

procedure TForm1.btPauseClick(Sender: TObject);
begin
  // pause animation
  FliPlayer1.Pause;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Case Fliplayer1.FliPos of
    FliLeft : RPos.Itemindex:=0;
    FliCentre : RPos.Itemindex:=1;
    FliRight : RPos.Itemindex:=2;
  end;
  CheckBox2.Checked:=FliPlayer1.Stretch;
  Checkbox1.Checked:=FliPlayer1.Loop;
  SpinEdit1.Value:=FliPlayer1.SpeedOverride;
end;

procedure TForm1.FliPlayer1FliPaint(Sender: TObject; FrameNo: Word);
Var
 Bm : TBitmap;
begin

  IF ShowText then
   Begin
    { bm:=TBitmap.create;
     with bm do
      begin
        pixelformat:=pf8bit;
        width:=150;
        height:=45;
      end;
     with bm.Canvas do
      Begin
       TextOut(5,2,' Copyright MindBlast Software 1998 ');
       textOut(5,19,' This text is just to show how easy it is to use ');
       textOut(5,36,' the canvas. Click on Readme button to remove text... ');
      end;
      bitBlt(FliPlayer1.BackGround.Handle,0,0,bm.width,bm.height,bm.canvas.handle,0,0,srcCopy);
      bm.Free;}

   BM:=TBitMap.Create;
   With BM do
    Begin
      pixelformat:=pf8bit;
      width:=320;
      height:=100;
      canvas.Brush.Style:=bsClear;
      canvas.Font.color:=clLime;
      Canvas.TextOut(2,2,' Copyright MindBlast Software 1998 ');
      Canvas.textOut(2,19,' This text is just to show how easy it is to use ');
      Canvas.textOut(2,36,' the canvas. Click on Readme button to remove text... ');
    end;
    bitBlt(FliPlayer1.BackGround.DC,3,1,BM.Canvas.TextWidth(' the canvas. Click on Readme button to remove text... ')+2,
    (BM.Canvas.TextHeight('MBS')+2)*4,bm.canvas.handle,0,0,srcCopy);
    BM.free;

   End; {}
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 FliPlayer1.SeekFrame(FliPlayer1.CurrentFrame-1);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 FliPlayer1.SeekFrame(FliPlayer1.CurrentFrame+1);
end;

procedure TForm1.SpinEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 Key:=0;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 foAbout.Show;
end;



procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  ShowText:=not ShowText;
  FoReadme.Show;
end;

procedure TForm1.RPosClick(Sender: TObject);
begin
  Case RPos.Itemindex of
    0 : Fliplayer1.FliPos:=FliLeft;
    1 : Fliplayer1.FliPos:=FliCentre;
    2 : Fliplayer1.FliPos:=FliRight;
  end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 ShowText:=not ShowText;
 foReadme.Show;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 foAbout.Show;
end;

procedure TForm1.btFullScreenClick(Sender: TObject);
begin
 Form1.BorderStyle:=bsNone;
 Form1.WindowState:=wsMaximized;
 Details.Visible:=False;
 Controls.Visible:=False;
 btReturn.Visible:=True;

end;

procedure TForm1.btReturnClick(Sender: TObject);
begin
 Form1.BorderStyle:=bsSizeable;
 Form1.WindowState:=wsNormal;
 Details.Visible:=True;
 Controls.Visible:=True;
 btReturn.Visible:=False;
end;



end.
