unit unAniSettings2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, Mask;

type
  TfoAniSettings2 = class(TForm)
    cMemory: TCheckBox;
    cFull: TCheckBox;
    cLoop: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    lFrames: TLabel;
    lSpeed: TLabel;
    LDuration: TLabel;
    rbJiffies: TRadioButton;
    rbFrames: TRadioButton;
    Label4: TLabel;
    ESpeed: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    eLoop: TMaskEdit;
    eDuration: TMaskEdit;
    lForever1: TLabel;
    lForever2: TLabel;
    Label8: TLabel;
    seTimer: TSpinEdit;
    LOne1: TLabel;
    lOne2: TLabel;
    cStretch: TCheckBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure rbJiffiesClick(Sender: TObject);
    procedure eLoopExit(Sender: TObject);
    procedure eDurationExit(Sender: TObject);
    procedure ESpeedExit(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cLoopClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpDateSet;
  end;

var
  foAniSettings2: TfoAniSettings2;

implementation

uses unMBSPlayerMain;

{$R *.DFM}
Var
 MyLoopFrames  : Cardinal;
 MySpeed       : Cardinal;
 MyDuration    : LongInt;
 MyTotalFrames : Integer;


Procedure DoLabels;
Begin

 IF MyLoopFrames<>0 then
   foAniSettings2.cLoop.Checked:=True;
 foAniSettings2.cLoop.Enabled:=MyLoopFrames=0;
 
 foAniSettings2.lOne1.Visible:=(MyLoopFrames=0) and (not (foAniSettings2.cLoop.Checked=True));
 foAniSettings2.lOne2.Visible:=(MyLoopFrames=0) and (Not (foAniSettings2.cLoop.Checked=True));
 foAniSettings2.lForever1.Visible:=(MyLoopFrames=0) and ((foAniSettings2.cLoop.Checked=True));
 foAniSettings2.lForever2.Visible:=(MyLoopFrames=0) and ((foAniSettings2.cLoop.Checked=True));

End;

procedure TfoAniSettings2.UpdateSet;
Var
 S        : ShortString;
begin
 If MySpeed <=0 then MySpeed:=1;
 cLoop.Enabled:=MyLoopFrames=0;
 foAniSettings2.cLoop.Checked:=True;
 MyDuration:=(MyTotalFrames*MySpeed);


 If rbJiffies.Checked then
  Begin
    ESpeed.Text:=IntToStr(Round(MySpeed/((1/70)*1000)));
  end
  Else
  Begin
    ESpeed.Text:=FloatToStrF(1000/(MySpeed+0.00001),ffFixed,6,1);
  End;

  ELoop.Text:=Copy('00'+IntToStr(MyLoopFrames div MyTotalFrames),Length(IntToStr(MyLoopFrames Div MyTotalFrames)),3)+':'+
                Copy('00'+IntToStr(MyLoopFrames mod MyTotalFrames),Length(IntToStr(MyLoopFrames mod MyTotalFrames)),3);

   MyDuration:=(MyLoopframes*MySpeed);
   s:=Copy('0'+IntToStr(MyDuration div (60*1000)),Length(IntToStr(MyDuration div (60*1000))),2);
   MyDuration:=(MyDuration mod (60*1000));
   s:=s+':'+Copy('0'+IntToStr(MyDuration div (1000)),Length(IntToStr(MyDuration div (1000))),2);
   MyDuration:=(MyDuration mod (1000));
   s:=s+'.'+Copy('00'+IntToStr(MyDuration),Length(IntToStr(MyDuration)),3);

   EDuration.Text:=s;
   DoLabels;
end;
procedure TfoAniSettings2.BitBtn2Click(Sender: TObject);
begin
 Close;
end;

procedure TfoAniSettings2.FormShow(Sender: TObject);
Var
 S        : ShortString;
begin
 MyLoopFrames:=LoopFrames;
 foMain.Fli.Play;
 foMain.Fli.Pause;
 cLoop.Checked:=FoMain.Fli.Loop;
 cStretch.Checked:=FoMain.Fli.Stretch;

 seTimer.Value:=FoMain.Fli.TimerInterval;
 rbFrames.Checked:=True;
 MyTotalFrames:=FoMain.Fli.TotalFrames;
 lFrames.Caption:=IntToStr(FoMain.Fli.TotalFrames);

 If (foMain.Fli.DefSpeed <> 0) or (foMain.Fli.SpeedOverride<>0) then
  Begin
   lSpeed.Caption:=FloatToStrF(1000/(foMain.Fli.DefSpeed+0.0000001),ffFixed,6,1);
   If (foMain.Fli.SpeedOverride<>0) then
    MySpeed:=foMain.Fli.SpeedOverride
   Else MySpeed:=foMain.Fli.DefSpeed;


   MyDuration:=(FoMain.Fli.TotalFrames*foMain.Fli.DefSpeed);
   s:=Copy('0'+IntToStr(MyDuration div (60*1000)),Length(IntToStr(MyDuration div (60*1000))),2);
   MyDuration:=(MyDuration mod (60*1000));
   s:=s+':'+Copy('0'+IntToStr(MyDuration div (1000)),Length(IntToStr(MYDuration div (1000))),2);
   MyDuration:=(MyDuration mod (1000));
   s:=s+'.'+Copy('00'+IntToStr(MyDuration),Length(IntToStr(MyDuration)),3);

   lDuration.Caption:=s;
   ESpeed.Text:=FloatToStrF(1000/MySpeed,ffFixed,6,1);
   ELoop.Text:=Copy('00'+IntToStr(MyLoopFrames div FoMain.Fli.TotalFrames),Length(IntToStr(MyLoopFrames Div FoMain.Fli.TotalFrames)),3)+':'+
                Copy('00'+IntToStr(MyLoopFrames mod FoMain.Fli.TotalFrames),Length(IntToStr(MyLoopFrames mod FoMain.Fli.TotalFrames)),3);

   MyDuration:=(MyLoopframes*MySpeed);
   s:=Copy('0'+IntToStr(MyDuration div (60*1000)),Length(IntToStr(MyDuration div (60*1000))),2);
   MyDuration:=(MyDuration mod (60*1000));
   s:=s+':'+Copy('0'+IntToStr(MyDuration div (1000)),Length(IntToStr(MyDuration div (1000))),2);
   MyDuration:=(MyDuration mod (1000));
   s:=s+'.'+Copy('00'+IntToStr(MyDuration),Length(IntToStr(MyDuration)),3);

   EDuration.Text:=s;
  end;
 If Test then
 Begin
  RestoreOld;
  Test:=False;
 end; 
 foMain.Fli.Stop;
 DoLabels;
end;



procedure TfoAniSettings2.BitBtn1Click(Sender: TObject);
begin
 LoopFrames:=MyLoopFrames;
 FoMain.Fli.TimerInterval:=seTimer.Value;
 FoMain.Fli.Loop:=cLoop.Checked;
 foMain.Fli.Stretch:=cStretch.Checked;

 If MySpeed <> FoMain.Fli.DefSpeed then
   FoMain.Fli.SpeedOverride:=MySpeed
 Else FoMain.Fli.SpeedOverride:=0;
 Close;

end;

procedure TfoAniSettings2.rbJiffiesClick(Sender: TObject);
begin
 UpdateSet;
 DoLabels;
end;

Function RemoveSpaces(S : String):String;
Var
 Res : String;
 T : Byte;
Begin
  Res:='';
  For T:= 1 to Length(S) do
   Begin
     Case s[t] of
      '0'..'9',':','.' : Res:=Res+s[t];
      ' ' : Res:=Res+'0';
     end;
   End;
  RemoveSpaces:=Res;
End;

procedure TfoAniSettings2.eLoopExit(Sender: TObject);

var
 S : ShortString;
 P : Byte;
begin
    s:=ELoop.Text;
    s:=RemoveSpaces(S);
   P:=Pos(':',s);
   IF P<>0 then
    Begin
     MyLoopFrames:=(StrToInt(Copy(s,1,P-1))*MyTotalFrames)+StrToInt(Copy(s,P+1,Length(S)-P));
    End;

     ELoop.Text:=Copy('00'+IntToStr(MyLoopFrames div MyTotalFrames),Length(IntToStr(MyLoopFrames Div MyTotalFrames)),3)+':'+
                Copy('00'+IntToStr(MyLoopFrames mod MyTotalFrames),Length(IntToStr(MyLoopFrames mod MyTotalFrames)),3);

   MyDuration:=(MyLoopframes*MySpeed);
   s:=Copy('0'+IntToStr(MyDuration div (60*1000)),Length(IntToStr(MyDuration div (60*1000))),2);
   MyDuration:=(MyDuration mod (60*1000));
   s:=s+':'+Copy('0'+IntToStr(MyDuration div (1000)),Length(IntToStr(MyDuration div (1000))),2);
   MyDuration:=(MyDuration mod (1000));
   s:=s+'.'+Copy('00'+IntToStr(MyDuration),Length(IntToStr(MyDuration)),3);
   eDuration.Text:=s;
   DoLabels;

end;
procedure TfoAniSettings2.eDurationExit(Sender: TObject);
Var
 S : String;
 P,P2 : Byte;
begin
   s:=EDuration.Text;
   s:=RemoveSpaces(S);
   P:=Pos(':',s);
   P2:=Pos('.',s);
   IF (P<>0) and (P2<>0) then
    Begin
     MyDuration:=(StrToInt(Copy(s,1,P-1))*60*1000)+
                 (StrToInt(Copy(s,P+1,(P2)-(P+1)))*1000)+
                 (StrToInt(Copy(s,P2+1,Length(S)-P2)));
    End;

   MyLoopFrames:=Round(MyDuration/(MySpeed+0.00001));

   MyDuration:=(MyLoopframes*MySpeed);
   s:=Copy('0'+IntToStr(MyDuration div (60*1000)),Length(IntToStr(MyDuration div (60*1000))),2);
   MyDuration:=(MyDuration mod (60*1000));
   s:=s+':'+Copy('0'+IntToStr(MyDuration div (1000)),Length(IntToStr(MyDuration div (1000))),2);
   MyDuration:=(MyDuration mod (1000));
   s:=s+'.'+Copy('00'+IntToStr(MyDuration),Length(IntToStr(MyDuration)),3);
   eDuration.Text:=s;

   ELoop.Text:=Copy('00'+IntToStr(MyLoopFrames div MyTotalFrames),Length(IntToStr(MyLoopFrames Div MyTotalFrames)),3)+':'+
                Copy('00'+IntToStr(MyLoopFrames mod MyTotalFrames),Length(IntToStr(MyLoopFrames mod MyTotalFrames)),3);

   DoLabels;

end;
procedure TfoAniSettings2.ESpeedExit(Sender: TObject);
Var
 S : String;
begin
 S:=ESpeed.Text;
 S:=RemoveSpaces(s);
 If rbJiffies.Checked then
  MySpeed:=Round(StrToFloat('0'+s)*(1/70)*1000)
 Else Myspeed:=Round(1000/(StrToFloat('0'+s)+0.00001));
 If MySpeed <=0 then MySpeed:=1;
 eLoopExit(Sender);
 DoLabels;
end;



Procedure TfoAniSettings2.BitBtn3Click(Sender: TObject);
begin
 FrameCount:=0;
 OldLoopFrames:=LoopFrames;
 OldInterval:=FoMain.Fli.TimerInterval;
 OldLoop:=FoMain.Fli.Loop;
 OldStretch:=foMain.Fli.Stretch;
 OldSpeed:=FoMain.Fli.SpeedOverride;

 LoopFrames:=MyLoopFrames;
 FoMain.Fli.TimerInterval:=seTimer.Value;
 FoMain.Fli.Loop:=cLoop.Checked;
 foMain.Fli.Stretch:=cStretch.Checked;

 If MySpeed <> FoMain.Fli.DefSpeed then
   FoMain.Fli.SpeedOverride:=MySpeed
 Else FoMain.Fli.SpeedOverride:=0;
 Test:=True;
 FoMain.Fli.Play;
 Close;
end;


procedure TfoAniSettings2.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 foMain.Loop1.Checked:=foMain.Fli.Loop;
 foMain.Stretch1.Checked:=foMain.Fli.Stretch;
 foMain.Fli.Preview(1);
end;

procedure TfoAniSettings2.cLoopClick(Sender: TObject);
begin
 DoLabels;
end;

End.
